----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    10:32:04 03/30/2012 
-- Design Name: 
-- Module Name:    ClkDivTest - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity ClkDivTest is
    Port ( CLK : in  STD_LOGIC;
           RST : in  STD_LOGIC;
           LED : out  STD_LOGIC;
           Ausgang1 : out  STD_LOGIC;
           Ausgang2 : out  STD_LOGIC);
end ClkDivTest;

architecture Behavioral of ClkDivTest is
  signal CLK20: STD_LOGIC;
  signal Ausgang1Buf: STD_LOGIC;
  signal Ausgang2Buf: STD_LOGIC;
begin

  CLK_Proc: process(CLK, RST)
    variable DIV3: natural range 0 to 3; -- 60->20 MHz, NAND-Flash kann nur mit 40 MHz betrieben werden
  begin
    if RST = '0' then
      CLK20   <= '1';
      DIV3    := 0;
      Ausgang2Buf <= '0';
    else
      if (CLK'event) then
        Ausgang2Buf <= Not Ausgang2Buf;
        DIV3    := DIV3    + 1;
        if DIV3 = 3 then CLK20 <= Not CLK20; DIV3 := 0; end if;
      end if;    
    end if;
  end process;
  
  Read_Proc: process(CLK20, RST)
  begin
    if RST = '0' then
      Ausgang1Buf <= '0';
    else
      if (CLK20'event) then
        Ausgang1Buf <= Not Ausgang1Buf;
      end if;
    end if;
  end process;

  LED      <= Ausgang1Buf;
  Ausgang1 <= Ausgang1Buf;
  Ausgang2 <= Ausgang2Buf;

end Behavioral;

